void close_trains_matcher(CloseTrainsMatchSet *results) {
  CTVars vars = {t=NULL, ot=NULL, s=NULL, m=NULL, e=NULL}
  int match_cntr = 0;
  // Constraint: (*@\color{codecommentcolor}\(\exists t: \mathtt{Train}(t)\)@*)
  int loop_bound0 = model->train_count;
  for (int i0 = 0; i0 < loop_bound0; i0++) {
    vars->t = model->trains[i0];
    // Constraint: (*@\color{codecommentcolor}\(\mathtt{Location}(t,s)\)@*)
    vars->s = vars->t->location;
    if (vars->s != NULL) {
      // Constraint: (*@\color{codecommentcolor}\(\exists m: \mathtt{ConnectedTo}(s,m)\)@*)
      int loop_bound1 = vars->s->connected_to_count;
      for (int i1 = 0; i1 < loop_bound1; i1++) {
        vars->m = vars->s->connected_to[i1];
        // Constraint: (*@\color{codecommentcolor}\(\mathtt{ConnectedTo}(m,e)\)@*)
        int loop_bound2 = vars->m->connected_to_count;
        for (int i2 = 0; i2 < loop_bound2; i2++) {
          vars->e = vars->m->connected_to[i2];
          // Constraint: (*@\color{codecommentcolor}\(\neg (s = t)\)@*)
          if (vars->s != vars->e) {
            // Constraint: (*@\color{codecommentcolor}\(\exists \mathit{ot} :\mathtt{OccupiedBy}(e,\mathit{ot})\)@*)
            vars->ot = vars->e->train;
            if (vars->ot != NULL) {
              // Register match
              results->matches[match_cntr].s = vars->s;
              results->matches[match_cntr++].e = vars->e;
  } } } } } }
  results->size = match_cntr; }
